/* x-arith.h
 _______________________________________________________________________
|									|
|			      Projet LCS				|
|			  Groupe OLC, CNRS/LAAS				|
|			 7, Av. du Colonel Roche			|
|			   31077 Toulouse Cedex				|
|_______________________________________________________________________|

Foreign function interface; allocation macros;

Version 5.0.18; June 99;

*/


#define MkAddr(p)     (AllocAddr(p))
#define DeAddr(a)     (GetLong(a,0))



/* 1. bools: ---------------------------------------------------------- */

#define MkBool(b) 		(MkVal((num)(b)))
#define True			(Un)
#define False			(Zero)
#define DeBool(w)        	(w==True)	/* eqv. DeVal(w)	*/

#define ToBool(w)     ((int)(DeBool(w)))
#define FromBool(n)   (MkBool(n))


/* 2. integers: ------------------------------------------------------- */

#define MkNum(n) 		(MkVal((num)(n)))
#define DeNum(w)		(DeVal(w))	/* entiers 31 bits	*/

extern void stringOfNum(char *, num);
extern word numOfString (word); /* Error returned means failure */

#define ToChar(w)     ((char)(DeNum(w)))
#define FromChar(n)   (MkNum(n))

#define ToUChar(w)    ((unsigned char)(DeNum(w)))
#define FromUChar(n)  (MkNum(n))

#define ToShort(w)    ((short)(DeNum(w)))
#define FromShort(n)  (MkNum(n))

#define ToUShort(w)   ((unsigned short)(DeNum(w)))
#define FromUShort(n) (MkNum(n))

#define ToInt(w)      ((int)(DeNum(w)))
#define FromInt(n)    (MkNum(n))

#define ToUInt(w)     ((unsigned int)(DeNum(w)))
#define FromUInt(n)   (MkNum(n))

#define ToLong(w)     ((long)(DeNum(w)))
#define FromLong(n)   (MkNum(n))

#define ToULong(w)    ((unsigned long)(DeNum(w)))
#define FromULong(n)  (MkNum(n))



/* 3. reals: ---------------------------------------------------------- */

/* unaligned doubles (optimization for ALIGN_DOUBLE targets skipped ...) */
#define AllocReal(d)            (AllocDouble(d))
#define allocReal(r,d)          {allocDouble(r,d);}
#define GetReal(r)              (GetDouble(r))

#define ToDouble(w)    (GetDouble(w))
#define FromDouble(d)  (AllocReal(d))

extern double doubleOfString(word, int *);  /* flag set means failure */
extern void stringOfDouble(char *, double);

