/* x-string.h
 _______________________________________________________________________
|									|
|			      Projet LCS				|
|			  Groupe OLC, CNRS/LAAS				|
|			 7, Av. du Colonel Roche			|
|			   31077 Toulouse Cedex				|
|_______________________________________________________________________|

Foreign functions interface, string headers.

Version 5.0; June 99;

*/






/* strings: ------------------------------------------------------------ */

/* encoding character strings:
- empty string is encoded MkVal(0);
- single character string c is encoded MkVal((unsigned)c+1);
- multi character strings encoded as Char chunks, without trailing \0;
*/

#define MkChar(c) 		(MkVal(1+(num)(byte)c))
#define DeChar(w)   		(byte)(DeVal(w)-1)
#define IsChar(w)    		((IsVal(w)) && (w!=Zero))

#define String(w) 		((IsVal(w)) ? (CHARS+(DeVal(w))): Chars(w))
#define StringSize(w)		((IsVal(w)) ? (Zero!=w) : (CharsSize(w)))
#define GetString(w,n)  	((IsVal(w)) ? (DeChar(w)) : (GetChar(w,n)))
#define IsEmptyString(w)        (w==Zero)
extern char CHARS[];            /* precomputed */

/* allocation; s is a C-string: */
#define allocString(r,s) 	{if (s[0]) \
				   {if (s[1]) {int n = strlen(s); allocChars(r,n); \
					       Cpystr(r,s);} \
				    else {r=MkChar(s[0]);}} \
				 else {r=Zero;}}
#define String(w) 		((IsVal(w)) ? (CHARS+(DeVal(w))): Chars(w))
#define StringSize(w)		((IsVal(w)) ? (Zero!=w) : (CharsSize(w)))
#define GetString(w,n)  	((IsVal(w)) ? (DeChar(w)) : (GetChar(w,n)))
#define IsEmptyString(w)        (w==Zero)
extern word AllocString(char *);     /* arg is a C-string */

/* C-string<->lcs-string conversions: */
#define ToString(buffer,w)      (Strcpy(buffer,w))  /* lcs string in w -> C string in buffer */
#define FromString(s)           (AllocString(s))    /* C-string -> lcs string */
extern char *Strcpy(char *, word);   /* copies lcs string into C-string */
extern word Cpystr(word, char *);    /* copies C-string into lcs-string */

/* string comparisons: */
extern num Strsup();
extern num Strsupe();
#define SupString(s1,s2)        (Strsup(s1,s2))
#define SupeString(s1,s2)       (Strsupe(s1,s2))
#define EqString(s1,s2)         ((s1==s2) ? (1) : EqConst(s1,s2))

/* num<->lcs-string conversions: */
extern void stringOfNum(char *,num);
extern word numOfString(word);




