(* bench.lcs
 _______________________________________________________________________
|                                                                       |
|                             Projet LCS                                |
|                         Groupe OLC, CNRS/LAAS                         |
|                        7, Av. du Colonel Roche                        |
|                          31077 Toulouse Cedex                         |
|_______________________________________________________________________|

some usual benchmarking functions.

*)


(* signature:

structure Bench =
   val ackermann : int -> int -> int
   val fact : int -> int
   val fact : mp -> mp
   val fib : int -> int
   val fib : mp -> mp
   val ftak : int -> int -> int -> int
   val ptak : int * int * int -> int

*)



structure Bench =
struct

overload fib; (* with integers and mp integers. *)
fun fib 0 = 1 | fib 1 = 1 | fib n = fib (n-1) + fib (n-2) ;
fun fib 00 = 01 | fib 01 = 01 | fib n = fib (n-01) + fib (n-02) ;
nonoverload fib;

overload fact; (* with integers and mp integers. *)
fun fact 0 = 1 | fact n = n * fact (n-1);
fun fact 00 = 01 | fact n = n * fact (n-01);
nonoverload fact;

fun ptak (x,y,z) = (* ptak (18,12,6) = 7 *)
	if not (y < x) then z
	else ptak (ptak (x-1,y,z), ptak (y-1,z,x), ptak (z-1,x,y));

fun ftak x y z = (* ftak 18 12 6 = 7 *)
	if not (y < x) then z
	else ftak (ftak (x-1) y z) (ftak (y-1) z x) (ftak (z-1) x y);

fun ackermann 0 m = m+1
  | ackermann n 0 = ackermann (n-1) 1
  | ackermann n m = ackermann (n-1) (ackermann n (m-1)) ;

end;
