(* dev.sml
 _______________________________________________________________________
|									|
|			      Projet LCS				|
|			  Groupe OLC, CNRS/LAAS				|
|			 7, Av. du Colonel Roche			|
|			   31077 Toulouse Cedex				|
|_______________________________________________________________________|

lcs devices, needed by Io, Stdio and Remote.

*)




(* interface

abstype dev			(* lcs devices, include streams	 *)
exception Io : string -> exn	(* failure of i/o op on a device *)

nulldev : dev
dopen : string * int -> dev      (* later: string * string -> >.. *)
dclose : dev -> unit
dgetc : dev -> string
dgets : dev * int -> string
dgetl : dev -> string
dputs : dev * string -> unit
dputl : dev * string -> unit
locks : dev * int -> bool
flush : dev * string -> bool
is_term : dev -> bool
de_dev : dev -> int * int * string	(* status+buff, desc, owner *)

*)



(* implementation *)

structure Dev = Core.Dev;


(* notes

locks:
	Locks an lcs device, to prevent lcs processes to access 
	it concurrently. Returns true if lock succeeded;	
       	second arg: 2 -> R unlock
	 	    4 -> W unlock
	   	    6 -> RW unlock
		    3 -> R lock
		    5 -> W lock
		    7 -> RW lock
		    _ -> no effect (returns false)
TO BE PROVIDED:

	fun flags d = ...
	fun buffer d = ...
	fun desc d = ..
	fun owner d = ...
*)

