(* socket.sml
 _______________________________________________________________________
|									|
|			      Projet LCS				|
|			  Groupe OLC, CNRS/LAAS				|
|			 7, Av. du Colonel Roche			|
|			   31077 Toulouse Cedex				|
|_______________________________________________________________________|

raw remote connections services.

*)




(* interface

structure Socket =

   exception Remote : string -> exn
   val open_service_ : string * int -> Dev.dev * string * int
   val close_service_ : Dev.dev * string * int -> unit
   val accept_connection_ : Dev.dev * string * int -> Dev.dev
   val open_connection_ : Dev.dev * string * int -> Dev.dev
   val close_connection_ : Dev.dev -> unit
   type key = dev * string * int * string
*)




(* implementation *)

structure Socket =
struct
open Core.Socket;
type key = Dev.dev * string * int * string   
	(* socket * host * port * passwd *)
end;



