(* stdio.sml
 _______________________________________________________________________
|									|
|			      Projet LCS				|
|			  Groupe OLC, CNRS/LAAS				|
|			 7, Av. du Colonel Roche			|
|			   31077 Toulouse Cedex				|
|_______________________________________________________________________|

primitives for input/output on standard window.

*)




(* interface

val std_window : unit -> window
val redirect_window : window -> window

val std_input : unit -> instream
val read : int -> string
val read_line : unit -> string
val redirect_input : instream -> instream

val std_output : unit -> outstream
val write : string -> unit
val write_line : string -> unit
val redirect_output : outstream -> outstream

val std_control : unit -> control
val wait : init -> string
val redirect_control : control -> control

*)




(* implementation: 

The   toplevel operates on a  default   window, initially std_win. The
default window is kept in reference STD_WIN_  (in dev).  io primitives
std_window and redirect_window allow to  access STD_WINDOW and replace
it by another window. The functions above allow more subtle updates of
STD_WINDOW, and   help  performing input/ouput operations   using that
default window.  *)


(* 
fun std_window () =
fun redirect_window w = 

fun std_input () = win_in (std_window ());
fun read n = input (std_input(),n);
fun read_line () = input_line (std_input());
fun redirect_input ii = 
	let val w = std_window ()
	in win_in (redirect_window (redirect_win (w,(win_ctrl w,ii,win_out w))))
	end;

fun std_output () = win_out (std_window ());
fun write s = output (std_output(),s);
fun write_line s = output_line (std_output(),s);
fun redirect_output oo = 
	let val w = std_window ()
	in win_out (redirect_window (redirect_win (w,(win_ctrl w,win_in w,oo))))
	end;

fun std_control () = win_ctrl (std_window ());
fun wait () = wait_ctrl (std_control());
fun redirect_control cc =
	let val w = std_window ()
	in win_ctrl (redirect_window (redirect_win (w,(cc,win_in w,win_out w))))
	end;
*)



structure Stdio = Core.Stdio;



