(* vector.sml
 _______________________________________________________________________
|									|
|			      Projet LCS				|
|			  Groupe OLC, CNRS/LAAS				|
|			 7, Av. du Colonel Roche			|
|			   31077 Toulouse Cedex				|
|_______________________________________________________________________|

vectors

*)




(* interface

type 'a vector
exception Subscript : exn
exception Size : exn
val vector : 'a list -> 'a vector
val length : 'a vector -> int
val sub : 'a vector * int -> 'a
val tabulate : int * (int -> 'a) -> 'a vector

*)



(* implementation *)


structure Vector =
struct

open Core.Vector;

fun tabulate (n,f) =
        if n<=0 then if n<0 then raise Size else #[] else
        let primitive vect : int -> 'a vector = [196]
	    primitive accu : 'a * 'b -> 'b = []
	    val k = ref 0
	in while !k<n
	   do accu (f (!k), inc k);
	   vect n
	end;

fun vector [] = #[]
  | vector l =
	let primitive vect : int -> 'a vector = [196]
	    primitive accu : 'a * 'b -> 'b = []
	    primitive Ref : 'a -> 'a ref = [146]
	    val k = Ref l
	    val n = List.length l
	in while not (null (!k))
	   do accu (hd (!k), k := tl (!k));
	   vect n
	end;
end;


